const _is                   = require("nv-validator-json-is");
    const {_un,_nu,_t,_f}   = _is;
const _tree                 = require("nv-data-tree-csp-tuple-bw");
const _T                    = require("./t").N2SEQ;
const _func                 = require("./func");


class Node extends _tree._Node {
    constructor(
        forest=null,id=-1,blocked=_f,
        T=_T.un,
        val=_un,
        key=_un,
        calced=_un,
        required=_t
    ) {
        super(forest,id,blocked);
        this[3] = T;
        this[4] = val;
        this[5] = key;
        this[6] = calced;
        this[7] = required
    }
    ////
    get required_()       {return(this[7])}
    is_optional()         {return(!this[7])}
    is_required()         {return(this[7])}
    optional()            {this[7]=_f}
    require()             {this[7]=_t}
    ////
    get typ_()            {return(this[3])}
    set_typ_to_ary()      {this[3]=_T.ary}
    set_typ_to_dict()     {this[3]=_T.dict}
    is_ary()              {return(this[3]===_T.ary)}
    is_dict()             {return(this[3]===_T.dict)}
    is_container()        {return(this.is_ary() || this.is_dict())}
    is_leaf()             {return(!this.is_container())}
    ////
    get ["#calced_"]()    {return(this[6])}
    set ["#calced_"](j)   {this[6] = j}
    ["#clear_calced"]()   {this[6] =_un}
    calc(
         leaf_func= (self)=>self.val_,
         del_rslt_after_calc=_t
    ) {
         if(del_rslt_after_calc) {
             return(_func._calc_and_del_rslt(this,(self)=>self.val_)) 
         } else {
             return(_func._calc_and_keep_rslt(this,(self)=>self.val_))
         }
    }
    reset_calced() {
        let g = this.$gen_sdfs_next();
        for(let nd of g) {
            nd[6] = _un
        }
    }
    creat_jtmpl()        {return(_func._calc_and_del_rslt(this,(self)=>_un))}
    dump_for_validator() {return(_func._calc_and_del_rslt(this,(self)=>self.val_.toString()))}
    ////    
    is_root()       {return(this[5]===_nu)}
    _is_ele()       { return(this.$parent_.is_ary())}
    is_ele()        {
        if(this.is_root()) {
            return(_f)
        } else {
            return(this._is_ele())
        }
    }
    _is_prop()      { return(this.$parent_.is_dict())}
    is_prop()       {
        if(this.is_root()) {
            return(_f)
        } else {
            return(this._is_dict())
        }
    }
    ////
    get val_()            {return(this[4])}
    get key_()            {return(this[5])}
    get idx_()            {return(this.$sibseq_)}
    get koi_()            {
        if(this.is_root()) {
            return(_nu)
        } else if(this._is_ele()) {
            return(this.idx_)
        } else {
            return(this.key_)
        }
    }
    get pl_()             {
        let pl = this.$plances_.slice(1);
        pl = pl.map(nd=>nd.koi_);
        return(pl)
    }
    get pls_() {
        let sdfs = this.$sdfs_;
        return(sdfs.map(nd=>nd.pl_))
    }
    ////
    append_leaf(v,k=_un) {
        let chnd = this.$append_child();
        chnd[4]  = v;
        chnd[5]  = k;
        return(chnd)
    }
    arsib_leaf(v,k=_un)  {
        let rsibnd = this.$add_rsib();
        rsibnd[4]  = v;
        rsibnd[5]  = k;
        return(rsibnd)
    }
    alsib_leaf(v,k=_un)  {
        let lsibnd = this.$add_lsib();
        lsibnd[4]  = v;
        lsibnd[5]  = k;
        return(lsibnd)
    }
    ////
    append_ary(k=_un)   {
        let chnd = this.$append_child();
        chnd[3]  = _T.ary;
        chnd[5]  = k;
        return(chnd)
    }
    arsib_ary(k=_un)    {
        let rsibnd = this.$add_rsib();
        rsibnd[3]  = _T.ary;
        rsibnd[5]  = k;
        return(rsibnd)
    }
    alsib_ary(k=_un)    {
        let lsibnd = this.$add_lsib();
        lsibnd[4]  = _T.ary;
        lsibnd[5]  = k;
        return(lsibnd)
    }    
    append_dict(k=_un)  {
        let chnd = this.$append_child();
        chnd[3]  = _T.dict;
        chnd[5]  = k;
        return(chnd)
    }
    arsib_dict(k=_un)   {
        let rsibnd = this.$add_rsib();
        rsibnd[3]  = _T.dict;
        rsibnd[5]  = k;
        return(rsibnd)
    }
    alsib_dict(k=_un)   {
        let lsibnd = this.$add_lsib();
        lsibnd[4]  = _T.dict;
        lsibnd[5]  = k;
        return(lsibnd)
    }
    ///
    append(j,k=_un)     {
        let forest = this.$forest_;
        let Ctor   = this.constructor;
        if(this.is_ary()) {
            let chnd = _func.creat_from_j(forest,Ctor,j);
            this.$append_child(chnd);
            return(chnd)
        } else if(this.is_dict()) {
            let chnd = _func.creat_from_j(forest,Ctor,j);
            chnd[5] = k;
            this.$append_child(chnd);
            return(chnd) 
        } else {
            return(_nu)
        }
    }
    arsib(j,k=_un)      {
        if(this.is_ary()) {
            let rsibnd = _func.creat_from_j(forest,Ctor,j);
            this.$add_rsib(rsibnd);
            return(rsibnd)
        } else if(this.is_dict()) {
            let rsibnd = _func.creat_from_j(forest,Ctor,j);
            rsibnd[5] = k;
            this.$add_rsib(rsibnd);
            return(rsibnd)
        } else {
            return(_nu)
        }
    }
    alsib(j,k=_un)      {
        if(this.is_ary()) {
            let lsibnd = _func.creat_from_j(forest,Ctor,j);
            this.$add_lsib(lsibnd);
            return(lsibnd)
        } else if(this.is_dict()) {
            let lsibnd = _func.creat_from_j(forest,Ctor,j);
            lsibnd[5] = k;
            this.$add_lsib(lsibnd);
            return(lsibnd)
        } else {
            return(_nu)
        }
    }
    //
    koiget_chnd(koi) {
        if(this.is_ary()) {
            let g = this.$gen_child_from_fst();
            let idx = 0;
            for(let chnd of g) {
                if(idx === koi) {
                    return(chnd)
                } else {}
                idx++;
            }
            return(_nu)
        } else if(this.is_dict()) {
            let g = this.$gen_child_from_fst();
            for(let chnd of g) {
                if(chnd.key_ === koi) {
                    return(chnd)
                } else {}
            }
            return(_nu)            
        } else {
            return(_nu)
        }
    }
    plget_nd(pl=[]) {
        let lngth = pl.length;
        if(lngth === 0) {
            return(this)
        } else {
            let pnd = this;
            for(let i=0;i<lngth;i++) {
                let koi = pl[i];
                pnd = pnd.koiget_chnd(koi);
                if(pnd!==_nu) {
                } else {
                    return(_nu)
                }
            }
            return(pnd)
        }
    }
    plget_vr(pl=[]) {
        let nd = this.plget_nd(pl);
        if(nd === _nu) {
            return([_un,_un])
        } else {
            let r = nd.required_;
            let v = nd.calc(_t);
            return([v,r])
        }
    }
    plget_v(pl=[]) {return(plget_vr(pl)[0])}
    plget_r(pl=[]) {return(plget_vr(pl)[1])}
}


Node.ALGN_DESC    = ["typ_","val_","key_","#calced_","required_"];
Node.ALGN_OFFSET  = 3;
Node.ALGN_SIZE    = 5;

module.exports    = Node;
